/*

 Definitions.H - Main 128Gamma Variable Definition File

*/

//--------------------------------------------------------------------

#if defined(__cplusplus)
#error This Program was designed to be compiled using C not C++.
#endif

#define TitleCaption "128Gamma - NetWorkDLS"
#define Version "Version 2.0 - Revision B"

#define ENCFlag "Secure128~"
#define PACFlag "Packed128~"

#define VersionInfo 10000
#define BufferSize 1

#include "Headers/PackDef.H" // PackDef.H Include File

//--------------------------------------------------------------------
        /* Global FILE Handles */ // Begin

FILE *Working_File, *CypherTemp_File, *EncryptTemp_File;

        /* Global FILE Handles */ // End
//--------------------------------------------------------------------
        /* Thread Handles, ID's And Prototypes*/ // Begin

extern DWORD WINAPI EncryptProcess_Thread(LPVOID);
static HANDLE EncryptProcess_Thread_Handle;
static long EncryptProcess_Thread_ID;

extern DWORD WINAPI DecryptProcess_Thread(LPVOID);
static HANDLE DecryptProcess_Thread_Handle;
static long DecryptProcess_Thread_ID;

extern DWORD WINAPI StatusDialog_Thread(LPVOID );
static HANDLE StatusDialog_Thread_Handle;
static long StatusDialog_Thread_ID;

extern DWORD WINAPI UnpackProcess_Thread(LPVOID);
static HANDLE UnpackProcess_Thread_Handle;
static long UnpackProcess_Thread_ID;

extern DWORD WINAPI PackProcess_Thread(LPVOID);
static HANDLE PackProcess_Thread_Handle;
static long PackProcess_Thread_ID;

        /* Thread Handles, ID's And Prototypes*/ // End
//--------------------------------------------------------------------
        /* Various Function Prototypes */ // Begin

extern void SetText (HWND, char *);
extern void CenterWindow (HWND);
extern void Error(char *);

extern char *GetText (HWND);
extern char *GetTempDirectory(void);
extern char *CipherKey(char []);

extern int WINAPI WinMain (HWND, HWND, LPSTR, int );
extern int PasswordDialog (HWND, int , int , int );
extern int AboutDialog (HWND, int , int , int );
extern int StatusDialog (HWND , int , int , int );

extern int Cipher(char *, char *, char *);
extern int Decipher(char *, char *, char *);
extern int IncodeMain(char *, char *);
extern int DecodeMain(char *, char *);

extern int EncryptProcess(void);
extern int DecryptProcess(void);
extern int PackProcess(void);
extern int UnpackProcess(void);

extern int ProcessInput(char *);
extern int CancelProcess(void);
extern int Backup(void);

extern int CharInt (char *);
extern int CleanUp(int, int);
extern int Encrypted(char *);
extern int SetTempVariables(void);

extern short FileEmpty(char *);

        /* Various Function Prototypes */ // End
//--------------------------------------------------------------------
        /* Various Global Variables */ // Begin

static char EncryptTemp[257];
static char PackTemp[257];
static char BackupTemp[257];
static char GlobalFileName[256];
static char Password[75];
static char Directory[257];
static char *Status;
static char *CodedKey;
static char *MethodFlag;

static int End_Of_File = 0;

static short KeyLength = 0;

static long SourceFileSize = 0;
static float StatusValue = 0;

        /* Various Global Variables */ // End
//--------------------------------------------------------------------
        /* Various Windows Handles */ // Begin

static HWND hInstance = 0;
static HWND PasswordDialog_hWnd = 0;
static HWND AboutDialog_hWnd = 0;
static HWND StatusDialog_hWnd = 0;

static HWND PasswordEdit_hWnd = 0;
static HWND InfoTextStatic_hWnd = 0;

        /* Various Windows Handles */ // End
//--------------------------------------------------------------------
        /* Global Variables Used As Flags */ // Begin

static short Encrypt = 0;
static short Decrypt = 0;
static short Unpack = 0;
static short Pack = 0;

static short CancelFlag = 0;
static short Verifiy = 0;
static short DoneFlag = 0;

        /* Global Variables Used As Flags */ // End
//--------------------------------------------------------------------


