/*
 Functions.H - Main 128Gamma Functions File

extern void Error(char *Message, int Restore)
extern int CleanUp(int Kill, int Delete)
extern int Encrypted(char *FileToCheck)
extern int SetTempVariables()
extern int CharInt(char *string2convert)
extern char *GetTempDirectory(void)
extern void SetText (HWND hDlg, char *Txt)
extern char *GetText (HWND hDlg)
extern void CenterWindow (HWND hWnd)
extern short FileEmpty(char *File2Size)
extern int EncryptProcess(void)
extern int DecryptProcess(void)
extern int PackProcess(void)
extern int UnpackProcess(void)
extern int ProcessInput(char *xInput)
extern char *CipherKey(char InputPassword[71])
extern DWORD WINAPI UnpackProcess_Thread(LPVOID data)
extern DWORD WINAPI PackProcess_Thread(LPVOID data)
extern DWORD WINAPI DecryptProcess_Thread(LPVOID data)
extern DWORD WINAPI EncryptProcess_Thread(LPVOID data)
extern DWORD WINAPI StatusDialog_Thread(LPVOID data)
extern int CancelProcess(void);
extern int Backup(void);

*/

//--------------------------------------------------------------------

#include "Headers/PackFunc.H" // PackFunc.H Include File

//--------------------------------------------------------------------

//////////////////////////////////////////////////////////////////////

extern void Error(char *Message)
{
	MessageBox (GetActiveWindow(), Message ,TitleCaption,0 + MB_ICONHAND + MB_SYSTEMMODAL);
	CleanUp(1,1);
}

//////////////////////////////////////////////////////////////////////

extern int CleanUp(int Kill, int Delete)
{
	if(Working_File)fclose(Working_File);
	if(CypherTemp_File)fclose(CypherTemp_File);
	if(EncryptTemp_File)fclose(EncryptTemp_File);


	if(Delete)
	{
		unlink(EncryptTemp);
		unlink(PackTemp);
		unlink(BackupTemp);
	}

	if(Kill)
	{
		unlink(EncryptTemp);
		unlink(PackTemp);
		unlink(BackupTemp);
		exit(0);
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////

extern int Encrypted(char *FileToCheck)
{
	static FILE * FileToCheck_File;

	if(FileToCheck_File)fclose(FileToCheck_File);

	if((FileToCheck_File = fopen(FileToCheck,"rb")) == NULL)
		Error("Could Not Open Source For Read. Error: 10.");

	static char Buffer[BufferSize*2];
	Buffer[0] = '\0';

	fread(Buffer,sizeof(char),10,FileToCheck_File);

	if(strcmp(Buffer,ENCFlag) == 0)
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		End_Of_File = 0;
		return 1;
	}

	if(strcmp(Buffer,PACFlag) == 0)
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		End_Of_File = 0;
		return 2;
	}

	if(FileToCheck_File)
		fclose(FileToCheck_File);
	return 3;
}

//////////////////////////////////////////////////////////////////////

extern int SetTempVariables()
{
	sprintf(EncryptTemp,"%s\\%s",GetTempDirectory(),"Encrypt.128G");
	sprintf(PackTemp,"%s\\%s",GetTempDirectory(),"Pack.128G");
	sprintf(BackupTemp,"%s\\%s",GetTempDirectory(),"Backup.128G");
	if(!BackupTemp)
		return 1;
	if(!EncryptTemp)
		return 1;
	if(!PackTemp)
		return 1;
	return 0;
}

//////////////////////////////////////////////////////////////////////

extern int CharInt(char *string2convert)
{
	int i, lenght_string;
	int power;
	int tmp_number;
	char tmp_char;
	if (!string2convert)
	{
		string2convert = "0";
		Error("Character To Interger Conversion Error. Error: 11.");
		return -1;
	}
	lenght_string = strlen(string2convert);
	for(i = 0; i < (lenght_string / 2); i++)
	{
		tmp_char = string2convert[i];
		string2convert[i] = string2convert[lenght_string - 1 - i];
		string2convert[lenght_string - 1 - i] = tmp_char;
	}
	power = 1;
	i = 0;
	tmp_number = 0;
	while (string2convert[i] != '\0')
	{
		tmp_number += (string2convert[i] - '0') * power;
		power *= 10;
		i++;
	}
	return tmp_number;
}

/////////////////////////////////////////////////////////////////////

extern char *GetTempDirectory(void)
{
	static char StrFunction [64][257];
	static int StrCnt;
	static char T [257];
	GetTempPath (256,T);
	if (++StrCnt==64) StrCnt = 0;
	sprintf(StrFunction[StrCnt],"%s",T);
	return StrFunction[StrCnt];
}

//////////////////////////////////////////////////////////////////////

extern void SetText (HWND hDlg, char *Txt)
{
	SendMessage(hDlg,(UINT)WM_SETTEXT,(WPARAM)0,(LPARAM)Txt);
}

/////////////////////////////////////////////////////////////////////

extern char *GetText (HWND hDlg)
{
	static short LocalLoop;
	static int StrCnt;
	static int T;
	static char xBuffer[2048];
	LPSTR StrFunc [16];
	LocalLoop = 0;
	StrCnt = 0;
	while(LocalLoop < 16)
	{
		StrFunc[LocalLoop] = '\0';
		LocalLoop++;
	}
	if (++StrCnt==16) StrCnt = 0;
	if (StrFunc[StrCnt]) free (StrFunc[StrCnt]);
	StrFunc[StrCnt] = (char*) malloc (2048);
	memset (StrFunc[StrCnt],0,2048);
	T=GetWindowTextLength(hDlg);
	GetWindowText(hDlg,xBuffer,T+1);
	sprintf(StrFunc[StrCnt],"%s",xBuffer);
	return StrFunc[StrCnt];
}
/////////////////////////////////////////////////////////////////////

extern void CenterWindow (HWND hWnd)
{
	static	RECT  wRect;
	static	DWORD  x;
	static	DWORD  y;
	GetWindowRect(hWnd,&wRect);
	x=(GetSystemMetrics(SM_CXSCREEN)-(wRect.right-wRect.left))/2;
	y=(GetSystemMetrics(SM_CYSCREEN)-(wRect.bottom-wRect.top+GetSystemMetrics(SM_CYCAPTION)))/2;
	SetWindowPos(hWnd,NULL,x,y,0,0,SWP_NOSIZE|SWP_NOZORDER);
}

/////////////////////////////////////////////////////////////////////

extern short FileEmpty(char *File2Size)
{
	FILE *fp;
	static short size;
	size = 0;

	if((fp = fopen(File2Size,"r+b")) == NULL)
	{
		Error("Could Not Open Source For Read. Error 12.");
		return 0;
	}

	while(!feof(fp))
	{
		fgetc(fp);
		if(!feof(fp))
		{
			size++;
		}

		if(size > 0)
		{
			if(fp)fclose(fp);
			return 0;
		}

		if(ferror(fp))
		{
			Error("Error Sizing File. Error 13.");
			return 0;
		}
	}

	if(fp)fclose(fp);
	if(size == 0)return 1;
	return 0;
}

/////////////////////////////////////////////////////////////////////

extern int EncryptProcess(void)
{
	CleanUp(0,1);

	Pack = 0;
	Decrypt = 0;
	Encrypt = 0;
	Unpack = 0;

	if(Backup())
	{
		DoneFlag = 1;
		CleanUp(0,1);
		return(0);
	}

	Status = "Calculating File Size...";
	SourceFileSize = FileSize(GlobalFileName);

	Status = "Ciphering...";
	/* EnCode(Source,Target,Password); */
	if(Cipher(GlobalFileName,EncryptTemp,GetText(PasswordEdit_hWnd)))
	{

		Status = "Re-Calculating File Size...";
		SourceFileSize = FileSize(EncryptTemp);

		Status = "Encoding...";
		/* IncodeMain(Source,Target); */
		if(IncodeMain(EncryptTemp,GlobalFileName))
		{
			Status = "Data Successfully Encrypted!";
		}

	}

	DoneFlag = 1;
	CleanUp(0,1);

	return(0);
}

/////////////////////////////////////////////////////////////////////

extern int DecryptProcess(void)
{
	CleanUp(0,1);

	Pack = 0;
	Decrypt = 0;
	Encrypt = 0;
	Unpack = 0;

	if(Backup())
	{
		DoneFlag = 1;
		CleanUp(0,1);
		return(0);
	}

	Status = "Calculating File Size...";
	SourceFileSize = FileSize(GlobalFileName);

	Status = "Decoding...";
	if(DecodeMain(GlobalFileName,EncryptTemp))
	{

		Status = "Re-Calculating File Size...";
		SourceFileSize = FileSize(EncryptTemp);

		Status = "Deciphering...";
		if(Decipher(EncryptTemp,GlobalFileName,GetText(PasswordEdit_hWnd)))
		{
			Status = "Data Successfully Decrypted!";
		}
	}

	DoneFlag = 1;
	CleanUp(0,1);

	return(0);
}

//////////////////////////////////////////////////////////////////////

extern int PackProcess(void)
{
	CleanUp(0,1);

	Status = "Packing Files...";
	if(PackFiles(GlobalFileName,Directory))
	{
		ShowWindow(StatusDialog_hWnd,TRUE);

		Status = "Calculating File Size...";
		SourceFileSize = FileSize(GlobalFileName);

		Status = "Ciphering...";
		/* EnCode(Source,Target,Password); */
		if(Cipher(GlobalFileName,EncryptTemp,GetText(PasswordEdit_hWnd)))
		{

			Status = "Re-Calculating File Size...";
			SourceFileSize = FileSize(EncryptTemp);

			Status = "Encoding...";
			/* IncodeMain(Source,Target); */
			if(IncodeMain(EncryptTemp,GlobalFileName))
			{
				Status = "Files Successfully Packed!";
			}
		}
	}

	DoneFlag = 1;
	CleanUp(0,1);

	return(0);
}

//////////////////////////////////////////////////////////////////////

extern int UnpackProcess(void)
{
	CleanUp(0,1);

	static char xPath[257];
	static char xDrive[11];

	xPath[0] = '\0';
	xDrive[0] = '\0';

	static char SourceFilePath[257];
	/* Split Drive And Path Of SourceFileName And Set Then To (SourceFilePath) */

	_splitpath(GlobalFileName,xDrive,xPath,NULL,NULL);
	sprintf(SourceFilePath,"%s%s",xDrive,xPath);

	Status = "Calculating File Size...";
	SourceFileSize = FileSize(GlobalFileName);

	Status = "Decoding...";
	if(DecodeMain(GlobalFileName,EncryptTemp))
	{

		Status = "Re-Calculating File Size...";
		SourceFileSize = FileSize(EncryptTemp);

		Status = "Deciphering...";
		if(Decipher(EncryptTemp,PackTemp,GetText(PasswordEdit_hWnd)))
		{
			Status = "UnPacking Files...";
			if(UnPackFiles(PackTemp,SourceFilePath))
			{
				Status = "Files Successfully UnPacked!";
				CleanUp(0,1);
			}
		}
	}

	DoneFlag = 1;
	CleanUp(0,1);

	return(0);
}

/////////////////////////////////////////////////////////////////////

extern int ProcessInput(char *xInput)
{
	static short ENCMethod;
	ENCMethod = 0;

	if(strlen(xInput) > 0) // If Any Program Input Params
	{
		static char Extention[27];
		static char xDrive[7];
		static char xPath[257];

		_splitpath(xInput,xDrive,xPath,NULL,Extention);

		sprintf(GlobalFileName,"%s",xInput);

		/* Empty And Extention Is .128 */
		if(FileEmpty(xInput) && (strcmp(Extention,".128") == 0))
		{
			sprintf(Directory,"%s%s",xDrive,xPath);
			MethodFlag = PACFlag;
			Pack = 1;
			Decrypt = 0;
			Encrypt = 0;
			Unpack = 0;
			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		/* ENCMethod ( 1 = Encrypted , 2 = Packed , 3 = NOT Encrypted) */

		MethodFlag = ENCFlag;
		ENCMethod = Encrypted(GlobalFileName);

		if(ENCMethod == 1) // Encrypted
		{
			Decrypt = 1;
			Encrypt = 0;
			Unpack = 0;
			Pack = 0;

			ENCMethod = 0;
			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			ENCMethod = 0;
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 2) //  Packed
		{
			Unpack = 1;
			Decrypt = 0;
			Encrypt = 0;
			Pack = 0;

			ENCMethod = 0;
			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			ENCMethod = 0;
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 3) // NOT Encrypted
		{
			Encrypt = 1;
			Unpack = 0;
			Decrypt = 0;
			Pack = 0;

			ENCMethod = 0;
			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			ENCMethod = 0;
			CleanUp(0,1);
			return(0);
		}
	}

	CleanUp(0,1);

	return 1;
}

/////////////////////////////////////////////////////////////////////

extern char *CipherKey(char InputPassword[71])
{
	static int LocalLoop;
	static char xCodedKey[27];
	LocalLoop = 0;

	while(LocalLoop < strlen(InputPassword))
	{
		xCodedKey[LocalLoop] = InputPassword[LocalLoop] + 128;
		LocalLoop++;
	}

	return xCodedKey;
}

/////////////////////////////////////////////////////////////////////

extern int CancelProcess(void)
{
	if(Pack || Unpack)return 0;

	static FILE *LocalSource_File;
	static FILE *LocalTarget_File;
	static float Current_Size;
	static short SentSize = 0;
	Current_Size = 0;

	Status = "Restoring Source File.";

	if((LocalSource_File = fopen(BackupTemp,"rb")) == NULL)
	{
		if(LocalSource_File)fclose(LocalSource_File);
		Error("Could Not Open For Read. Error 14.");
		return 0;
	}

	if((LocalTarget_File = fopen(GlobalFileName,"wb")) == NULL)
	{
		if(LocalTarget_File)fclose(LocalTarget_File);
		Error("Could Not Open For Write. Error 15.");
		return 0;
	}

	ClearBuffer();

	do
	{
		Current_Size++;
		StatusValue = (Current_Size / SourceFileSize * 100);
		SentSize = fread(Buffer,sizeof(char),BufferSize,LocalSource_File);
		fwrite(Buffer,sizeof(char),SentSize,LocalTarget_File);
	}
	while(SentSize == BufferSize);

	if(LocalSource_File)fclose(LocalSource_File);
	if(LocalTarget_File)fclose(LocalTarget_File);

	CleanUp(0,1);
	return 0;
}

/////////////////////////////////////////////////////////////////////

extern int Backup(void)
{
	static FILE *LocalSource_File;
	static FILE *LocalTarget_File;
	static short SentSize = 0;

	Status = "Backing Up Source File.";

	if((LocalSource_File = fopen(GlobalFileName,"rb")) == NULL)
	{
		if(LocalSource_File)fclose(LocalSource_File);
		Error("Could Not Open For Read. Error 16.");
		return 0;
	}

	if((LocalTarget_File = fopen(BackupTemp,"wb")) == NULL)
	{
		if(LocalTarget_File)fclose(LocalTarget_File);
		Error("Could Not Open For Write. Error 17.");
		return 0;
	}

	ClearBuffer();
	do
	{
		if(CancelFlag)
		{
			if(LocalSource_File)fclose(LocalSource_File);
			if(LocalTarget_File)fclose(LocalTarget_File);
			CleanUp(0,1);
			return 1;
		}
		SentSize = fread(Buffer,sizeof(char),BufferSize,LocalSource_File);
		fwrite(Buffer,sizeof(char),SentSize,LocalTarget_File);
	}
	while(SentSize == BufferSize);

	if(LocalSource_File)fclose(LocalSource_File);
	if(LocalTarget_File)fclose(LocalTarget_File);
	return 0;
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI StatusDialog_Thread(LPVOID data)
{
	DialogBox(hInstance,MAKEINTRESOURCE(200),0,StatusDialog);
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI EncryptProcess_Thread(LPVOID data)
{
	EncryptProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI DecryptProcess_Thread(LPVOID data)
{
	DecryptProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI PackProcess_Thread(LPVOID data)
{
	PackProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI UnpackProcess_Thread(LPVOID data)
{
	UnpackProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

