/*

 PackFunc.H - UnpackFiles And PackFiles Functions

extern long FileSize(char *File2Size)
extern int Get_NumberOfFiles(char CountFileTemp[257])
extern char *Get_CurrentDirectory(void)

*/

////////////////////////////////////////////////////////////////////////


#include "Headers/ClearVaraible.H" // ClearVariable.H Include File

////////////////////////////////////////////////////////////////////////

extern long FileSize(char *File2Size)
{
	FILE *fp;
	static long size;
	size = 0;

	SetFileAttributes(File2Size,FILE_ATTRIBUTE_NORMAL);

	if((fp = fopen(File2Size,"r+b")) == NULL)
	{
		if(fp)fclose(fp);
		Error("Size File Error. Error 20.");
		return -1;
	}
	while(!feof(fp))
	{
		fgetc(fp);
		if(!feof(fp))
		{
			size++;
		}
		if(ferror(fp))
		{
			if(fp)fclose(fp);
			Error("Size File Error. Error 21.");
			return -2;
		}
	}
	if(fp)fclose(fp);
	return size;
}

///////////////////////////////////////////////////////////////////////

extern int Get_NumberOfFiles(char CountFileTemp[257])
{
	static int LocalPlaceHolder;
	LocalPlaceHolder = 0;

	while(1)
	{
		while(CountFileTemp[LocalPlaceHolder] != '\0')
		{
			LocalPlaceHolder++;
		}
		LocalPlaceHolder++;
		if(CountFileTemp[LocalPlaceHolder] == '\0')break;
		Number_Of_Files++;
	}
	return Number_Of_Files;
}

///////////////////////////////////////////////////////////////////////

extern char *Get_CurrentDirectory(void)
{
	static int LocalLoop;
	static int StrCnt;
	StrCnt = 0;
	static LPSTR StrFunc[16];
	LocalLoop = 0;
	while(LocalLoop < sizeof(StrFunc))
	{
		StrFunc[LocalLoop] = '\0';
		LocalLoop++;
	}
	if (++StrCnt==16) StrCnt = 0;
	if (StrFunc[StrCnt]) free (StrFunc[StrCnt]);
	StrFunc[StrCnt] = (char*) malloc (2048);
	memset (StrFunc[StrCnt],0,2048);
	GetCurrentDirectory (1024,StrFunc[StrCnt]);
	return StrFunc[StrCnt];
}

////////////////////////////////////////////////////////////////////////


