/*
 UnPackFiles.H - Functions Used To Unpack Files From A Single File

extern int UnPackFiles(char *SourceFileName, char *Directory)

*/

////////////////////////////////////////////////////////////////////////

extern int UnPackFiles(char *SourceFileName, char *Directory)
{
	static FILE *Source_File;
	static FILE *Target_File;
	static int LocalLoop;
	static int FileSize;
	static int FileSizeCount;
	static int FileSizeLeft;
	static int LocalFileCount;
	static char FileName[257];
	static char CharBuffer;
	static char FullFileName[257];
	static char StatusTemp[257];

	static float Status_Number_Of_Files;
	static float Status_LocalFileCount;
	static float Status_Percent_Done;

	Buffer[0] = '\0';
	Status = "UnPacking Files...";

	/* Open Source File */
	if((Source_File = fopen(SourceFileName,"rb")) == NULL)
	{
		static char ErrorTemp[1024];
		sprintf(ErrorTemp,"Could Not Open %s For Read. Error 22.",SourceFileName);
		Error(ErrorTemp);
		return 0;
	}
	fseek(Source_File,0,SEEK_SET);

	// ------------------------------------------
	{ // (Begin) Get Number Of Files
		ClearBuffer();
		fread(Buffer,sizeof(char),4,Source_File);
		Number_Of_Files = CharInt(Buffer);
		fseek(Source_File,1,SEEK_CUR);
	} // (End) Get Number Of Files



	Status_Number_Of_Files = Number_Of_Files;

	while(LocalFileCount < Number_Of_Files)
	{
		// ------------------------------------------

		LocalFileCount++;

		Status_LocalFileCount = LocalFileCount;
		Status_Percent_Done = (Status_LocalFileCount / Status_Number_Of_Files) *100;
		StatusValue = Status_Percent_Done;
		sprintf(StatusTemp,"Unpacking File %d of %d",LocalFileCount,Number_Of_Files);
		Status = StatusTemp;

		// ------------------------------------------

		{ // (Begin) Get FileSize

			ClearBuffer();
			fread(Buffer,sizeof(char),8,Source_File);
			FileSize = CharInt(Buffer);
			fseek(Source_File,1,SEEK_CUR);
		} // (End) Get FileSize


		// ------------------------------------------

		{ // (Begin) Get FileName

			LocalLoop = 0;
			FileName[0] = '\0';
			while(LocalLoop < 257)
			{
				LocalLoop++;
				fscanf(Source_File, "%c", &CharBuffer);
				if(strcmp("/",&CharBuffer) == 0) break;
				strcat(FileName,&CharBuffer);
			}
		} // (End) Get FileName


		// ------------------------------------------

		{ // (Begin) Open And Write File

			sprintf(FullFileName,"%s\\%s",Directory,FileName);
			if((Target_File = fopen(FullFileName,"wb")) == NULL)
			{
				static char ErrorTemp[1024];
				sprintf(ErrorTemp,"Could Not Open %s For Write. Error 23.",FullFileName);
				Error(ErrorTemp);
				return 0;
			}
			ClearBuffer();

			/* If We Can Write The File In One Buffer */
			if(FileSize < sizeof(Buffer))
			{
				fread(Buffer,sizeof(char),FileSize,Source_File);
				fwrite(Buffer,sizeof(char),FileSize,Target_File);
			}
			else
				{
				FileSizeCount = 0;
				while(FileSizeCount <= FileSize)
				{
					FileSizeLeft = (FileSize - FileSizeCount);
					if( FileSizeLeft <= BufferSize)
					{
						if(CancelFlag)
						{
							if(Source_File)fclose(Source_File);
							if(Target_File)fclose(Target_File);
							unlink(FullFileName);
							CleanUp(0,1);
							return 0;
						}
						ClearBuffer();
						fread(Buffer,sizeof(char),FileSizeLeft,Source_File);
						fwrite(Buffer,sizeof(char),FileSizeLeft,Target_File);
						FileSizeCount = FileSizeCount + FileSizeLeft;
						break;
					}

					FileSizeCount = FileSizeCount + BufferSize;
					fread(Buffer,sizeof(char),BufferSize,Source_File);
					fwrite(Buffer,sizeof(char),BufferSize,Target_File);
				}
				if(FileSizeCount != FileSize)
				{
					static char ErrorTemp[1024];
					sprintf(ErrorTemp,"File Compare Error. Error 24.\n",FileName);
					Error(ErrorTemp);
					return 0;
				}
			}
			if(Target_File) fclose(Target_File);
		} // (End) Open And Write File


		// ------------------------------------------
	}

	if(Source_File)fclose(Source_File);
	if(Target_File)fclose(Target_File);

	return 1;
}

////////////////////////////////////////////////////////////////////////

